Subject: Re: bug#58041: [PATCH] docview: Use svg images when using mupdf for conversion

From: Visuwesh <[email-masked]>
Date: Thu, 12 Jan 2023 22:17:50 +0530

[வியாழன் ஜனவரி 12, 2023] Stefan Monnier via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:

>> --- a/lisp/doc-view.el
>> +++ b/lisp/doc-view.el
>> @@ -921,7 +921,7 @@ doc-view-shrink-factor
>>  (defun doc-view-enlarge (factor)
>>    "Enlarge the document by FACTOR."
>>    (interactive (list doc-view-shrink-factor))
>> -  (if doc-view-scale-internally
>> +  (if (or doc-view-scale-internally doc-view-mupdf-use-svg)
>>        (let ((new (ceiling (* factor doc-view-image-width))))
>>          (unless (equal new doc-view-image-width)
>>            (setq-local doc-view-image-width new)
>> @@ -941,7 +941,7 @@ doc-view-shrink
>>  (defun doc-view-scale-reset ()
>>    "Reset the document size/zoom level to the initial one."
>>    (interactive)
>> -  (if doc-view-scale-internally
>> +  (if (or doc-view-scale-internally doc-view-mupdf-use-svg)
>>        (progn
>>  	(kill-local-variable 'doc-view-image-width)
>>  	(doc-view-insert-image
>
> Hmm.... `doc-view-mupdf-use-svg` means "use SVG when the backend
> is mupdf" but we don't know here whether the backend is mupdf, so this
> will misfire when using something else than mupdf, no?

Ah yes, of course.  Somehow, I managed to completely forget about the
other file formats supported by doc-view like djvu (since I only use
file formats that use mupdf in the end).  How about the below revised
patch?

>From 70864205f1595815470639cd2ad47c5465206f03 Mon Sep 17 00:00:00 2001
From: Visuwesh <[email-masked]>
Date: Thu, 12 Jan 2023 12:03:49 +0530
Subject: [PATCH] Use internal image scaling when using SVG images in doc-view

* lisp/doc-view.el (doc-view-enlarge, doc-view-scale-reset): Default
to changing the :width image property when using SVG images even if
doc-view-scaling-internally is nil.
(doc-view--image-type): Document the new possible image type.  (bug#58041)
---
 lisp/doc-view.el | 10 +++++++---
 1 file changed, 7 insertions(+), 3 deletions(-)

diff --git a/lisp/doc-view.el b/lisp/doc-view.el
index 7c272f52fb..cdca17f5af 100644
--- a/lisp/doc-view.el
+++ b/lisp/doc-view.el
@@ -489,7 +489,7 @@ doc-view-single-page-converter-function
 
 (defvar-local doc-view--image-type nil
   "The type of image in the current buffer.
-Can be `png' or `tiff'.")
+Can be `png', `svg', or `tiff'.")
 
 (defvar-local doc-view--image-file-pattern nil
   "The `format' pattern of image file names.
@@ -921,7 +921,9 @@ doc-view-shrink-factor
 (defun doc-view-enlarge (factor)
   "Enlarge the document by FACTOR."
   (interactive (list doc-view-shrink-factor))
-  (if doc-view-scale-internally
+  (if (or doc-view-scale-internally
+          (and (eq doc-view--image-type 'svg)
+               doc-view-mupdf-use-svg))
       (let ((new (ceiling (* factor doc-view-image-width))))
         (unless (equal new doc-view-image-width)
           (setq-local doc-view-image-width new)
@@ -941,7 +943,9 @@ doc-view-shrink
 (defun doc-view-scale-reset ()
   "Reset the document size/zoom level to the initial one."
   (interactive)
-  (if doc-view-scale-internally
+  (if (or doc-view-scale-internally
+          (and (eq doc-view--image-type 'svg)
+               doc-view-mupdf-use-svg))
       (progn
 	(kill-local-variable 'doc-view-image-width)
 	(doc-view-insert-image
-- 
2.38.1

This does the expected on my end with doc-view-scale-internally to nil:
when visiting a djvu file and zooming in, it regenerates the images;
when visiting a docx file and zooming in, it modifies the :width image
property (i.e., no regeneration).

>>> I wasn't thinking of duplicating the code, but of rethinking the naming
>>> a bit.  I think what we meant by "pdf->png" is actually the process that
>>> extracts pages (which just happened to use the PNG format and now can
>>> also use the SVG format).
>
>> Indeed, it is a misleading name.  This change will have to go to master,
>> I believe?  I have to look around a bit more to see where the function
>> is being used.
>> There's also the fact that there's more than one more program that can
>> generate SVG files (as Gregory pointed out in this thread) so it might
>> be nice to have pdf->png and pdf->svg "function variables" and a "super
>> function" that actually does the job.  Hopefully, this will allow to
>> fall back gracefully to PNG if SVG generation is faulty.
>
> Indeed, I think there's some cleanup/orthogonalization in order here.

When I have more time and familiarity, I will try to give this a shot.

>         Stefan